## ld.so-1.9.5.tar.gz

=== d-link/Makefile ===
include ../Version.mk
include ../Config.mk

DIRS = $(ARCH) libdl

CFLAGS += -I. -I./$(ARCH) -DNO_UNDERSCORE -DVERBOSE_DLINKER \
	-DUSE_CACHE -fPIC -D__PIC__ #-funroll-loops

SRC2S = boot1.c hash.c readelflib1.c vsprintf.c

SRCS	= $(SRC1S) $(SRC2S)
OBJ1S	= $(SRC1S:.S=.o)
OBJ2S	= $(SRC2S:.c=.o)
OBJS	= $(OBJ1S) $(OBJ2S)

DLINKER = ld-linux.so

ELF_LDFLAGS=--shared # using GNU ld
#ELF_LDFLAGS=-G  # with SVr4 ld

lib:: $(OBJS)
	@for i in $(DIRS); do \
	  echo making $@ in $$i; \
	  ($(MAKE) -C $$i $@); \
	done;
	$(LD) -e _dl_boot $(ELF_LDFLAGS) -o $(DLINKER) \
	  -soname $(DLINKER).$(VMAJOR) *.o

obj: $(OBJS)

realclean::
	$(RM) -f .depend $(DLINKER) core *.o *.a *.s *.i tmp_make foo *~

clean::
	$(RM) -f $(DLINKER) core *.o *.a *.s *.i tmp_make foo *~

depend::
	$(CC) $(CFLAGS) -M $(SRCS) | \
		sed -e 's,^[ 	]*\(.*.o\)[ 	]*:,$(STATIC_DIR)/$(SUBDIR)/\1 $(SHARED_DIR)/$(SUBDIR)/\1 $(SHARED_LITE_DIR)/$(SUBDIR)/\1 $(DEBUG_DIR)/$(SUBDIR)/\1 $(PROFILE_DIR)/$(SUBDIR)/\1 $(CHECKER_DIR)/$(SUBDIR)/\1:,' > .depend
#	$(MAKE) subdir TARGET=depend

ifneq ($(DIRS),)
lib realclean clean depend::
	@for i in $(DIRS); do \
	  echo making $@ in $$i; \
	  ($(MAKE) -C $$i $@); \
	done;
endif

#
# include a dependency file if one exists
#
ifeq (.depend,$(wildcard .depend))
include .depend
endif

=== man/Makefile ===
include ../Version.mk
include ../Config.mk

ALL = ld.so.info

all:	$(ALL)

ld.so.info: ld.so.texi
	makeinfo $<

clean:
	rm -f $(ALL) *~

=== util/Makefile ===
include ../Version.mk
include ../Config.mk

ALL	= ldconfig ldd lddstub elf-ok

all:	$(ALL)

ldconfig: ldconfig.o readelf.o
	$(CC) -static $(CFLAGS) $(LDFLAGS) $^ -o $@

ldd:	ldd.o
	$(CC) -static $(CFLAGS) $(LDFLAGS) $^ -o $@

ldd.o:	ldd.c
	$(CC) -c $(CFLAGS) -DLDSO_ADDR=$(LDSO_ENTRY) $< -o $@

ifeq ($(DEBUG),true)
STUBFLAGS = -Wl,-dynamic-linker,../d-link/ld-linux.so
endif

lddstub: lddstub.o
	$(CC) $(CFLAGS) $(LDFLAGS) $(STUBFLAGS) $^ -o $@

elf-ok: elf-ok.S
	$(CC) $(CFLAGS) -nostartfiles -static -s $^ -o $@

clean:
	rm -f $(ALL) *.o *~ core

=== debian/changelog ===
ld.so (1.9.5-1) unstable; urgency=low

  * Fixed a bug in ldd where ld-linux.so.2 was not called
    correctly when run on shared libraries.
  * Fixed a problem in the previous version where some
    Makefiles were not architecture independent.

 -- David Engel <david@sw.ods.com>  Tue,  5 Aug 1997 20:13:22 -0500

ld.so (1.9.4-1) unstable; urgency=high

  * Fixed a bug in ld.so introduced in the previous version
    which broke preloads.
  * Turned a.out support back on by default, at least for the
    time being.  There are no promises to keep it.

 -- David Engel <david@sw.ods.com>  Sat, 26 Jul 1997 14:21:23 -0500

ld.so (1.9.3-1) unstable; urgency=high

  * Fixed buffer overflow bugs in ld-linux.so and ld.so.
  * Changed the README file a little to clarify a couple of
    things.
  * Changed ldconfig to chroot to the specified directory when
    the new -r option is used (Bob Tinsley).

 -- David Engel <david@sw.ods.com>  Mon, 21 Jul 1997 15:55:13 -0500

ld.so (1.9.2-3) unstable; urgency=low

  * Added a warning in the description not to downgrade to 
    version 1.8.x or earlier.
  * Changed /etc/ld.so.conf to not be a dpkg "conf" file 
    (Bug#9722).
  * Fixed a typo in debian/rules which affected m68k builds 
    (Bug#10025).

 -- David Engel <david@sw.ods.com>  Tue, 27 May 1997 10:27:48 -0500

ld.so (1.9.2-2) unstable; urgency=low

  * Added a libdl1-altdev package which can coexist with the
    libc6-dev package.

 -- David Engel <david@sw.ods.com>  Fri, 2 May 1997 21:45:40 -0500

ld.so (1.9.2-1) unstable; urgency=low

  * Removed /usr/local/lib from the default /etc/ld.so.conf
    for Debian (Bug#8181).
  * Changed ldconfig to be 64-bit clean (H.J. Lu).

 -- David Engel <david@sw.ods.com>  Tue, 22 Apr 1997 19:56:26 -0500

ld.so (1.9.1-1) unstable; urgency=low

  * Changed ldconfig to try to determine which libc a
    library is for even if it doesn't have an soname.
  * Fixed a bug in ldconfig where an older library using
    the glibc naming convention would be used instead of
    a newer library.
  * Changed to ld-linux.so and libdl.so to not require the 
    libc5 headers in order to compile.
  * Changed ldconfig and ldd to be compilable with either
    libc5 or libc6.

 -- David Engel <david@sw.ods.com>  Tue, 18 Mar 1997 20:46:50 -0600

ld.so (1.9.0-1) unstable; urgency=low

  * Changed to not build the old, a.out dynamic loader by
    default.
  * Changed instldso.sh to require the --force option to
    make sure users read the README file.
  * Changed instldso.sh to not install the libdl.so
    development files unless the --devfiles option is used.
  * Changed instldso.sh to not strip binaries and libraries
    if the --no-strip option is used.
  * Changed the Debian packaging to put the development files 
    which conflict with glibc in a new libdl1-dev package.
  * Changed ldd to use the glibc dynamic linker, if it is
    available, when run on a shared library.
  * Changed ld-linux.so to print the load addresses of
    libraries, ala glibc, when run by ldd.
  * Changed ld-linux.so to allow the libraries listed in 
    LD_PRELOAD to be separated by white space in addition to 
    colons.
  * Changed ld-linux.so to load the libraries listed in 
    LD_PRELOAD for setu/gid programs as long as they can be 
    loaded securely.
  * Changed ldconfig to update the symlinks for the dynamic
    linkers.
  * Changed ldconfig to try to determine if an ELF library is
    intended for libc5 or libc6 and save the infomation in the
    cache.  The mechanism used is rather simplistic and may
    need to be enhanced.
  * Changed ldconfig to print the type of ELF library when
    printing the cache.
  * Changed ld-linux.so to only load ELF shared libraries for
    use with libc5 or an unknown libc.

 -- David Engel <david@sw.ods.com>  Thu, 6 Mar 1997 20:25:22 -0600

ld.so (1.8.10-2) unstable; urgency=low

  * Changed the shlibs file so other packages would depend on ldso
    instead of libdl1.

 -- David Engel <david@sw.ods.com>  Mon, 3 Mar 1997 11:40:34 -0600

ld.so (1.8.10-1) stable unstable; urgency=low

  * Fixed a bug in ldconfig where a symlink could be used
    instead of a regular file.

  * Fixed a Debian packaging problem for the sparc 
    architecture.

 -- David Engel <david@debian.org>  Tue, 18 Feb 1997 20:49:23 -0600

ld.so (1.8.9-1) unstable; urgency=low

  * Changed ldconfig to only cache the symlinks it creates.
    This make the behavior of the dynamic linkers consistent
     with how they would behave if a cache was not used.

  * Changed ldconfig to cache the symlinks that it finds but
    use the name of the symlink as the soname instead of the 
    actual soname.

 -- David Engel <david@debian.org>  Sun, 9 Feb 1997 00:32:25 -0600

ld.so (1.8.8-1) stable unstable; urgency=low

  * Minor documentation updates to reflect recent changes.

  * Changed ld.so and ld-linux.so to perform more complete
    validation on ld.so.cache before using it.

  * Changed ldconfig to accept libraries with inconsistent
    sonames since glibc is going to use them.  A warning is
    still printed in debug mode.

  * Changed the install script to not strip _dl_debug_state
    from ld-linux.so since gdb needs it.

  * More sparc fixes (Derrick Brashear).

  * Changed ldconfig to not issue a warning when a linker
    script disguised as a shared library is found.

  * Fixed a bug in ld-linux.so where some registers were 
    not preserved on the first call to a function causing 
    problems for non-C-like languages (Tim Renouf).

  * Fixed a bug in ld-linux.so where global variables were 
    not always mapped correctly across dynamically loaded 
    libraries (Mikihiko Nakao).

  * Converted to new Debian source packaging format (Shaya
    Potter).

 -- David Engel <david@debian.org>  Sat, 25 Jan 1997 23:30:10 -0600

Local variables:
mode: debian-changelog
End:

=== debian/control ===
Source: ld.so
Section: base
Priority: required
Maintainer: David Engel <david@debian.org>
Standards-Version: 0.2.1.1

Package: ldso
Section: base
Priority: required
Essential: yes
Architecture: any
Provides: libdl1
Breaks: libc6 (<=2.0.1-1)
Description: The Linux dynamic linker, library and utilities.
 The dynamic linker provides the user-level support for loading and
 linking DLL and ELF shared libraries.  It is required by any program
 that uses shared libraries, which is just about all of them.
 .
 WARNING: Do NOT downgrade this package to version 1.8.x or earlier.
 Doing so may leave your system in an unusable state.

Package: libdl1-dev
Section: devel
Priority: standard
Architecture: any
Depends: ldso (=${Source-Version}), libc5-dev (>=5.4.0-0)
Replaces: libc
Conflicts: ldso (<<1.9.0-0), libc6-dev
Description: The Linux dynamic linker library (development files).
 The files in this package were formerly included in the ldso package.
 They were moved into this package because they conflict with the 
 libc6-dev package.

Package: libdl1-altdev
Section: devel
Priority: standard
Architecture: any
Depends: ldso (=${Source-Version}), libc5-altdev (>=5.4.0-0)
Description: The Linux dynamic linker library (alternative dev files).
 This package can be used to build libc5-based binaries even when 
 the libc6-dev package is installed.

=== debian/rules ===
#! /usr/bin/make -f
#
# Last updated: Thu Apr 26 22:00:00 CDT 1995 by david.
#
# To make the binary distribution package, the ``Debianized'' source package
# and the context diff to the original package, type `./debian.rules dist'.
# Make sure that `debian.rules' is executable before the final distribution
# is made.
#
# Invoke each target with `./debian.rules <target>'.  All targets should be
# invoked with the package root as the current directory.
#
# The `binary' target must be run as root, as it needs to install files with
# specific ownerships.  The `diff' target assumes that you have the original
# source package available, unpacked, in ../$(p)-$(v).orig, or that you have
# the previous revision of the ``Debianized'' source package and context diff
# in the parent directory.

include Version.mk
v = $(VERSION)
vm = $(VMAJOR)
arch = $(shell dpkg --print-architecture)
ifeq ($(arch),i386)
archx = i486
else
archx = $(arch)
endif

build:
# Builds the binary package.
	make ARCH=$(arch) clean
	make ARCH=$(arch)
	touch build

clean:
# Undoes the effect of `make -f debian.rules build'.
	make ARCH=$(arch) clean
	rm -f build
	rm -rf debian/tmp debian/files

binary-indep:   checkroot build
        $(checkdir)

binary-arch:    checkroot build
	$(checkdir)
	#
	##############################
	# build the ldso package
	rm -rf debian/tmp
	install -d -m 755 debian/tmp
	chmod g-s debian/tmp
	#
	install -d -m 755 debian/tmp/lib
	if [ -f ld-so/ld.so ]; then \
		install -s -m 755 ld-so/ld.so debian/tmp/lib/ld.so.$(v); \
	fi
	install -m 755 d-link/ld-linux.so debian/tmp/lib/ld-linux.so.$(v)
	strip -g -K _dl_debug_state debian/tmp/lib/ld-linux.so.$(v)
	ln -sf ld-linux.so.$(v) debian/tmp/lib/ld-linux.so.$(vm)
	install -s -m 755 d-link/libdl/libdl.so debian/tmp/lib/libdl.so.$(v)
	ln -sf libdl.so.$(v) debian/tmp/lib/libdl.so.$(vm)
	install -d -m 755 debian/tmp/sbin
	install -s -m 755 util/ldconfig debian/tmp/sbin/ldconfig.new
	#
	install -d -m 755 debian/tmp/usr/bin
	install -s -m 755 util/ldd debian/tmp/usr/bin/ldd
	install -d -m 755 debian/tmp/usr/lib
	install -s -m 755 util/lddstub debian/tmp/usr/lib/lddstub
	#
	install -d -m 755 debian/tmp/usr/man/man1
	install -m 644 man/ldd.1 debian/tmp/usr/man/man1/ldd.1
	install -d -m 755 debian/tmp/usr/man/man8
	install -m 644 man/ldconfig.8 debian/tmp/usr/man/man8/ldconfig.8
	install -m 644 man/ld.so.8 debian/tmp/usr/man/man8/ld.so.8
	gzip -9 debian/tmp/usr/man/man*/*
	install -d -m 755 debian/tmp/usr/info
	install -m 644 man/ld.so.info debian/tmp/usr/info
	gzip -9 debian/tmp/usr/info/*
	#
	install -d -m 755 debian/tmp/usr/doc/ld.so
	install -m 644 debian/copyright debian/tmp/usr/doc/ld.so/copyright
	install -m 644 README debian/tmp/usr/doc/ld.so/README
	gzip -9f debian/tmp/usr/doc/ld.so/README
	install -m 644 debian/changelog debian/tmp/usr/doc/ld.so/changelog
	gzip -9f debian/tmp/usr/doc/ld.so/changelog
	#
	install -d -m 755 debian/tmp/DEBIAN
	install -m 644 debian/shlibs debian/tmp/DEBIAN/shlibs
	uuencode util/elf-ok elf-ok > /tmp/elf-ok.uue
	sed -e '/^__END__/r /tmp/elf-ok.uue' debian/preinst \
		> debian/tmp/DEBIAN/preinst
	chmod 755 debian/tmp/DEBIAN/preinst
	rm -f /tmp/elf-ok.uue
	sed -e 's/VERSION/$(v)/g' -e 's/VMAJOR/$(vm)/g' debian/postinst \
		> debian/tmp/DEBIAN/postinst
	chmod 755 debian/tmp/DEBIAN/postinst
	install -m 755 debian/prerm debian/tmp/DEBIAN/prerm
	#
	dpkg-gencontrol -pldso
	chmod -R g-w debian/tmp
	chown -R root.root debian/tmp
	dpkg --build debian/tmp ..
	#
	##############################
	# build the libdl1-dev package
	rm -rf debian/tmp
	install -d -m 755 debian/tmp
	chmod g-s debian/tmp
	#
	install -d -m 755 debian/tmp/usr/lib
	ln -sf /lib/libdl.so.$(v) debian/tmp/usr/lib/libdl.so
	install -d -m 755 debian/tmp/usr/include
	install -m 644 d-link/libdl/dlfcn.h debian/tmp/usr/include/dlfcn.h
	#
	install -d -m 755 debian/tmp/usr/man/man3
	install -m 644 man/dlopen.3 debian/tmp/usr/man/man3/dlopen.3
	gzip -9 debian/tmp/usr/man/man*/*
	ln -sf dlopen.3.gz debian/tmp/usr/man/man3/dlsym.3.gz
	ln -sf dlopen.3.gz debian/tmp/usr/man/man3/dlerror.3.gz
	ln -sf dlopen.3.gz debian/tmp/usr/man/man3/dlclose.3.gz
	install -d -m 755 debian/tmp/usr/doc
	ln -sf ld.so debian/tmp/usr/doc/libdl1-dev
	#
	install -d -m 755 debian/tmp/DEBIAN
	dpkg-gencontrol -plibdl1-dev
	chmod -R g-w debian/tmp
	chown -R root.root debian/tmp
	dpkg --build debian/tmp ..
	#
	##############################
	# build the libdl1-altdev package
	rm -rf debian/tmp
	install -d -m 755 debian/tmp
	chmod g-s debian/tmp
	#
	install -d -m 755 debian/tmp/usr/$(archx)-linuxlibc1/lib
	ln -sf /lib/libdl.so.$(v) \
	  debian/tmp/usr/$(archx)-linuxlibc1/lib/libdl.so
	install -d -m 755 debian/tmp/usr/$(archx)-linuxlibc1/include
	install -m 644 d-link/libdl/dlfcn.h \
	  debian/tmp/usr/$(archx)-linuxlibc1/include/dlfcn.h
	#
	install -d -m 755 debian/tmp/usr/doc
	ln -sf ld.so debian/tmp/usr/doc/libdl1-altdev
	#
	install -d -m 755 debian/tmp/DEBIAN
	dpkg-gencontrol -plibdl1-altdev
	chmod -R g-w debian/tmp
	chown -R root.root debian/tmp
	dpkg --build debian/tmp ..

binary: binary-indep binary-arch

checkroot:
	test root = "`whoami`"

.PHONY: binary binary-arch binary-indep clean checkroot
